import java.awt.*;
import java.awt.event.*;

/** Things that act like some kind of Button,
 * providing a visual focus for mouse interaction. */

public interface ButtonLike {

/** Needed for drag-in / drag-out response */

    public boolean contains (int x, int y) ;

/** Set the Listener to provide some button behavior.
 * It will listen for both kinds of Mouse events,
 * so register it as both kinds of listener.
 * Remove any old one. */

    public void setListener (ButtonLikeListener ibl) ;

/** Get the current Listener. */

    public ButtonLikeListener getListener () ;

/** Set appearance Pressed or not */

    public void setPressed (boolean Pressed) ;

    public boolean isPressed () ;
        
/** setEnabled (false) repaints a disabled version,
 * and via isEnabled () disables response to input,
 * setEnabled (true) restores the enabled appearance,
 * and via isEnabled () enables response to input.  */

    public void setEnabled (boolean enable) ;

    public boolean isEnabled () ;

   public void enable () ;
   public void disable () ;

/** Extensions should override one or both of these, */

    public void processStateChange (boolean s) ;

    public void processAction () ;
}
